
#ifndef CSA_H_
#define CSA_H_

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/times.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>

#include <libcdsBasics.h>
#include <BitSequenceRRR.h>
#include <BitSequence.h>
#include <BitString.h>

#include "TSA.h"

using namespace std;
using namespace cds_utils;
using namespace cds_static;

extern "C" void suffixsort(int x[], int p[], int n, int k, int l);

double MakeSuffixArray(int alg, unsigned D, bool listTraza, bool runTest);
char *SubString(char * A,unsigned start, unsigned count);
void PrintSuffixArray(TSA *SArray,unsigned length);
unsigned SearchFromSA(char *pattern, TSA *SArray, unsigned length);
unsigned SearchFromCSA(char *pattern, TSA *SArray, unsigned length);
unsigned SearchFromSACount(char *pattern, TSA *SArray, unsigned length);
unsigned SearchFromCSACount(char *pattern, TSA *SArray, unsigned length);
unsigned SearchFromCSAWithLCP(char *pattern, TSA *SArray, unsigned length);
unsigned SearchFromSAWithLCP(char *pattern, TSA *SArray,unsigned length);
void UnCompactSuffixArray(unsigned D);
void UnCompactLink(TSA *CArray, unsigned Cindex, unsigned depth, TSA *Area, unsigned &Areasize, unsigned remaining, unsigned startparent);
void UnCompactLinkExp(TSA *CArray, unsigned Cindex, unsigned depth, unsigned *items, unsigned &Areasize, unsigned remaining, unsigned startparent);

BitSequence * saveLoad(BitSequence * bs);
double getTime (void);
void runExperiments(unsigned itemsExp2, unsigned itemsExp3);
unsigned accessIntervalFromSA(unsigned i, unsigned j, unsigned *items);
unsigned accessOneFromSA(unsigned pos);

#endif /* CSA_H_ */
