
#include "TSA.h"

void TSA::SetField(unsigned *A, unsigned len, unsigned index, unsigned x)
      {unsigned i=index*len/32,
                j=index*len-i*32;
       unsigned mask = (j+len < 32 ? ~0u << j+len : 0)
                       | (32-j < 32 ? ~0u >> (32-j) : 0);
       A[i] = (A[i] & mask) | x << j;
       if (j+len>32) {
          mask = ((~0u) << (len+j-32));
          A[i+1] = (A[i+1] & mask)| x >> (32-j);
       }
      };

unsigned TSA::GetField(unsigned *A, unsigned len, unsigned index)
      {unsigned i=index*len/32,
                j=index*len-32*i,
                result;
       if (j+len <= 32)
          result = (A[i] << (32-j-len)) >> (32-len);
       else {
          result = A[i] >> j;
          result = result | (A[i+1] << (32-(j+len-32))) >> (32-len);
       }
       return result;
      };

void TSA::printbits(unsigned x)
  {unsigned k; for (k=0; k<32; k++) printf("%d",x<<(32-k-1)>>31);
  printf("\n");};
void TSA::CreatePosArray(unsigned bits, unsigned n)
  {posbits = bits; pos = (unsigned *)malloc((n*bits)/8+1);
   CreateBooleanArray(n);};
void TSA::CreateLCPArray(unsigned bits, unsigned n, bool jump)
  {lcpbits = bits; lcp = (unsigned *)malloc((n*bits)/8+1);
  assert(lcp!=NULL); jumpinnext = jump;};
void TSA::CreateBooleanArray(unsigned n)
  {B = (unsigned *)malloc(n/8+1);};
void TSA::DeletePosArray() {free(pos);};
void TSA::DeleteLCPArray() {free(lcp);};
void TSA::DeleteBooleanArray(unsigned n) {free(B);};
void TSA::SetLCP(unsigned index,unsigned x)
  {x = x | ((GetField(lcp,lcpbits,index) >> (lcpbits-1)) << (lcpbits-1));
   SetField(lcp,lcpbits,index,x);};
void TSA::SetLCPl(unsigned index)
  {SetField(lcp,lcpbits,index,
   (1u<<(lcpbits-1)) | GetField(lcp,lcpbits,index));};
void TSA::SetLCPr(unsigned index)
  {SetField(lcp,lcpbits,index,
   GetField(lcp,lcpbits,index) & ~(1u<<(lcpbits-1)));};
void TSA::SetJump(unsigned index, unsigned x)
  {if (!jumpinnext) SetField(lcp,lcpbits/2,2*index,x);
   else SetField(lcp,lcpbits,index+1,x);};
void TSA::SetDepth(unsigned index, unsigned x)
  {if (!jumpinnext) SetField(lcp,lcpbits/2,2*index+1,x);
   else SetField(lcp,lcpbits,index,x);};
void TSA::SetPos(unsigned index, unsigned x)
  {SetField(pos,posbits,index,x);};
void TSA::SetB(unsigned index, unsigned x)
  {SetField(B,1,index,x);};
unsigned TSA::GetLCP(unsigned index)
  {return GetField(lcp,lcpbits,index) & ~(1<<(lcpbits-1));};
unsigned TSA::GetLCPl(unsigned index)
  {return GetField(lcp,lcpbits,index)>>(lcpbits-1);};
unsigned TSA::GetLCPr(unsigned index)
  {return GetField(lcp,lcpbits,index)>>(lcpbits-1)==0;};
unsigned TSA::GetJump(unsigned index)
  {if (!jumpinnext) return GetField(lcp,lcpbits/2,2*index);
   else return GetField(lcp,lcpbits,index+1);};
unsigned TSA::GetDepth(unsigned index)
  {if (!jumpinnext) return GetField(lcp,lcpbits/2,2*index+1);
   else return GetField(lcp,lcpbits,index);};
unsigned TSA::GetPos(unsigned index)
  {return GetField(pos,posbits,index);};
bool TSA::GetB(unsigned index)
  {return GetField(B,1,index);};
