#include <iostream.h>

#include "CSA.h"
using namespace std;

extern int optind;
extern char *filename;
extern char *text;
extern unsigned n;
extern unsigned m;
extern bool print;
extern int report;
extern unsigned C;
extern unsigned savemem;
extern TSA *SA;
extern TSA *CSA;
extern unsigned SuffixArrayCompactSize;

char buf[720000000];
char *wbuf;

BitSequence *Hs;
BitString *Rs;

int main(int argc, char *argv[]) {
	bool runSearch = false;			// true for execute count of pattern
	bool runTest = false;
	bool listTraza = false;
	unsigned itemsExp2 = 10;		// num of contiguous items to retrieve
	unsigned itemsExp3 = 20;		// num of contiguous items to retrieve
	double timeConstruction;
	unsigned D=10;

	int c;
	extern char *optarg;
	extern int optind;

	int nexec = 1;
	int alg = 0;
	int i;

	long nf;
	int nw;
	int nbuf, len;
	char *s;

	while((c = getopt(argc, argv, "e:a:p:r:C:D:s:")) != -1)
		switch(c)
		{
			case 'e':	nexec = atoi(optarg); break;
			case 'a':	alg = atoi(optarg); break;
			case 'p':	print = atoi(optarg); break;
			case 'r':	report = atoi(optarg); break;
			case 'C':	C = atoi(optarg); break;
			case 'D':	D = atoi(optarg); break;
			case 's':	savemem = atoi(optarg); break;
			default:	goto usage;
		}

	if((optind >= argc) || (optind+2 < argc)){
	usage:
		fprintf(stderr,
		"usage: %s [-a alg] [-e nex] [-p print] [-r report] [-C length] [-D depth] [-s savemem] [string] file\n", argv[0]);

		fprintf(stderr,"alg = {0=SearchCSA,1=SearchSA,2=SearchCSALCP,3=SearchSALCP,\n");
		fprintf(stderr,"       4=Uncompact,5=SearchCSALCPfit}\n");
		fprintf(stderr,"nex = number of execution times\n");
		fprintf(stderr,"print = {0,1}\n");
		fprintf(stderr,"existence,report,count = {0,1,2}\n");
		fprintf(stderr,"length = maximum length of the linked areas\n");
		fprintf(stderr,"depth = maximum length of the link paths\n");
		fprintf(stderr,"savemem = {0,1}\n");
		exit(1);
	}

	if((c = open(argv[argc-1], 0)) < 0){
		perror(argv[argc-1]);
		exit(1);
	}
	filename = (char *)malloc(sizeof(char)*(strlen(argv[argc-1])+1));

	nbuf = read(c, buf+1, 1000000000*sizeof(char));
	buf[++nbuf] = '#';
	buf[nbuf+1] = '\0';
	close(c);
	text = buf+1;
	n = nbuf;
	printf("len file = n = %d\n", n);

	//if(optind+2 == argc){
		len = strlen(argv[optind]);
		wbuf = (char *)malloc((len+3)*sizeof(char));
		strcpy(wbuf, argv[optind]);
		wbuf[len] = '\0';
		wbuf[len+1] = '\0';
	/*} else {
		wbuf = (char*)malloc(12000000*sizeof(char));
		i = 0;
		while((c = getchar()) != EOF) {
			wbuf[i++] = (c=='\n')? '\0':c;
		}
		wbuf[i++] = '\0'; wbuf[i] = '\0';
	}*/


	nf = nw = 0;
	if (alg !=7){
		cout << "Read file = " << argv[argc-1] << endl;
		cout << "Param C = " << C << endl;
		cout << "Param D = " << D << endl;
		timeConstruction = MakeSuffixArray(alg, D, listTraza, runTest);
		cout << "++++++++++++++++++++++++++++++++++++++++++" << endl;
		cout << "CPU time construction: " << timeConstruction * 1000.0 << " Milliseconds" << endl;
		cout << "++++++++++++++++++++++++++++++++++++++++++" << endl;
	}

	if (runSearch){
		for(s = wbuf; s[0] != '\0';) {
			nw++;
			len = strlen(s);
			m = len;
			for(c = 0; c < nexec; c++)
			   if (alg == 0 && report != 2)
				  nf += SearchFromCSA(s,CSA,SuffixArrayCompactSize);
			   else if (alg == 0)
				  nf += SearchFromCSACount(s,CSA,SuffixArrayCompactSize);
			   else if (alg == 1 && report != 2)
				  nf += SearchFromSA(s,SA,n);
			   else if (alg ==1)
				  nf += SearchFromSACount(s,SA,n);
			   else if (alg == 2)
				  nf += SearchFromCSAWithLCP(s,CSA,SuffixArrayCompactSize);
			   else if (alg == 3)
				  nf += SearchFromSAWithLCP(s,SA,n);
			   else if (alg == 4)
				   UnCompactSuffixArray(D);
			   else if (alg == 5)
				  nf += SearchFromCSAWithLCP(s,CSA,SuffixArrayCompactSize);
			if (alg == 4)
			   nf = 0;
			s += len;
			/* skip a possible empty word */
			if (s[0] == '\0')
				s++;
		}
	}

	//********************************************************************************************
	cout << "Run Experiments..." << endl;
	srand(time(NULL));
	runExperiments(itemsExp2, itemsExp3);

	cout << "Program Finished OK" << endl;
	cout << "_______________________________________________________________________________________________________" << endl;
	cout << "$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$" << endl << endl;
	return 0;
}
